﻿#include "define.h"

uniform int size;
uniform int width;

#if multisample
	layout(binding = 0, r32ui) writeonly uniform uimage2DMS   image_counter;
	layout(binding = 1, r32ui) writeonly uniform uimage2DMS   image_next;
#else
	layout(binding = 0, r32ui) writeonly uniform uimage2DRect image_counter;
	layout(binding = 1, r32ui) writeonly uniform uimage2DRect image_next;
#endif 

#if multisample
	void setPixelCounter      (ivec2 coords, uint val){imageStore(image_counter, coords, gl_SampleID, uvec4(val, 0U, 0U, 0U) );}
	void setPixelNextAddress  (ivec2 coords, uint val){imageStore(image_next   , coords, gl_SampleID, uvec4(val, 0U, 0U, 0U) );}
#else
	void setPixelCounter	  (ivec2 coords, uint val){imageStore(image_counter, coords, uvec4(val, 0U, 0U, 0U) );}
	void setPixelNextAddress  (ivec2 coords, uint val){imageStore(image_next   , coords, uvec4(val, 0U, 0U, 0U) );}
#endif

void main(void)
{
	ivec2 coords = ivec2(gl_FragCoord.xy);

	setPixelCounter		 (coords, 0U);
	setPixelNextAddress	 (coords, uint((coords.x + width*coords.y)*size));
}