﻿#include "define.h"

// INCLUDE
	vec4 computePixelColor();
// IN
#if multisample
	layout(binding = 0, r32ui) coherent  uniform uimage2DMS   image_counter;
	layout(binding = 1, r32ui) coherent  uniform uimage2DMS   image_next;
#else
	layout(binding = 0, r32ui) coherent  uniform uimage2DRect image_counter;
	layout(binding = 1, r32ui) coherent  uniform uimage2DRect image_next;
#endif 
	layout(binding = 2, rg32f) writeonly uniform  imageBuffer image_peel;

#if multisample
	uint addPixelFragCounter (ivec2 coords, uint val)	{ return imageAtomicAdd (image_counter, coords, gl_SampleID, val);}
	uint getPixelNextAddress (ivec2 coords			)	{ return imageLoad		(image_next	  , coords, gl_SampleID).x;}
#else
	uint addPixelFragCounter (ivec2 coords, uint val)	{ return imageAtomicAdd (image_counter, coords, val);}
	uint getPixelNextAddress (ivec2 coords			)	{ return imageLoad		(image_next	  , coords).x;}
#endif 
	void sharedPoolSetValue	 (uint index  , vec4 val)	{		 imageStore		(image_peel   , (int)(index), val);}

void main(void)
{
	ivec2 coords = ivec2(gl_FragCoord.xy);
	vec4  value  = vec4(packUnorm4x8(computePixelColor().abgr), gl_FragCoord.z, 0.0f, 0.0f);

	uint  count   = addPixelFragCounter(coords, 1U);
	uint  page_id = getPixelNextAddress(coords) + count;
	sharedPoolSetValue (page_id, value);
}
